// Copyright 2017 by Yun Xiang, Tam Chantem, and Robert Dick.
// All rights reserved.

/*Copyright 2010, Yun Xiang<xiangyun@umich.edu>.*/

/****************************************************************************
** main.cc
****************************************************************************/

#include <iostream>
#include <sstream>
#include <algorithm>
#include <vector>
#include "assert.h"
#include <fstream>
#include "configuration.h"
#include "Parse.h"
#include "Mttf.h"

using namespace std;

/*===========================================================================*/
int main(int argc, char* argv[]) {
  //  timer t;
  //t.start();
	configuration config(argc, argv);
	string rel_file = configuration::ap().rel_file();
	cout << "start mttf calculation" << endl;
	sys_mttf(rel_file);
	//t.stop();
	//cout << "Elapsed Time " << t << endl;
	

    //* print out each element's temperature
#if 0
	for (unsigned int i = 0; i < thermal_profile.size(); i++) {
		if (thermal_profile[i].center[Z_]==0){
			cout << thermal_profile[i].center[X_] << " ";
			cout << thermal_profile[i].center[Y_] << " ";
			cout << thermal_profile[i].center[Z_] << " ";
			cout << thermal_profile[i].size[X_] << " ";
			cout << thermal_profile[i].size[Y_] << " ";
			cout << thermal_profile[i].size[Z_] << " ";
			cout << thermal_profile[i].value << endl;
		}
	}
#endif    

    //Print out the resulting temperature profile for visualizing using gnuplot
    //print_hetero_eltvec_gnuplot(thermal_profile, 64);

    //Zoom-in a box of the chip defined by x = -4mm to x = 0mm, and y = -2mm to     
    //y = 4mm and recompute the steady-state temperature profile
    //thermal_profile = 
    //            isac.zoom_and_solve_static(-4.0, 0.0, -2.0, 4.0, power);

    //Reprint out the resulting temperature profile for gnuplot
    //print_hetero_eltvec_gnuplot(thermal_profile, 64);

    //Report the temperatures of devices inside the box defined by x = -1mm to x = 0mm and y = -1mm to y = 0mm
    //vector<Device_type> devices;

    //string layout_file = configuration::ap().layout_file();
    //devices = isac.report_device_temperatures(thermal_profile, layout_file, -1.0, 0.0, -1.0, 0.0);

    //Print out the device temperatures
    //for(unsigned int i = 0; i < devices.size(); i++) {
    //    cout << devices[i].loc[X_] << " " << devices[i].loc[Y_] << " ";
    //    cout << devices[i].loc[Z_] << " " << devices[i].temp << endl;
    //}
    /*======================================================================*/

    return 0;
}

